$('#jstree').jstree
( 
    {
        'plugins' : ['themes','html_data','ui','cookie'],
        'core' : {
            'data' : {
                'url' : '/foldertree',
                'dataType' : 'json',
                'data' : function (node)
                {
                      return { 'id' : node.id };
                }
            }
        }
    }
) 
.bind('select_node.jstree',    
    function (e, data)
    {
        var folderVals = "";
        for (let i = 0; i < data.selected.length; i++) {
            var objNode = data.instance.get_node(data.selected[i]);
            folderVals+='"' + objNode.id + '"' + ' ';
        }
        var input = document.getElementById('folder');
        input.value=folderVals;
    }
)

/*
* When user selects task from navbar makes it click the corresponding button
*/
document.querySelectorAll('a.dropdown-item[data-name]').forEach( function(link) {
  link.addEventListener('click', function(e) {
        e.preventDefault();
        document.querySelector('button[name="'+this.dataset.name+'"]').click();
  });
});

/*
* Remove existing alerts from modal dialog
*/
function removeAllAlerts(alerts)
{
    while (alerts.hasChildNodes()) {
      alerts.removeChild(alerts.lastChild);
    }
}

/**
* Add error msg to modal (remove existing messages first)
*/
function addAlertToModal(alerts, msg)
{
    removeAllAlerts(alerts);
    var alert = document.createElement("div");
    alert.innerHTML = msg;
    alert.className = "alert alert-danger";
    alerts.appendChild(alert);
}

/**
* Add info msg to modal (remove existing messages first)
*/
function addInfoToModal(alerts, msg)
{
    removeAllAlerts(alerts);
    var alert = document.createElement("div");
    alert.innerHTML = msg;
    alert.className = "alert alert-success";
    alerts.appendChild(alert);
}

/**
* Sort contents of select alphabetically
*/
function sortAlphabetically(selectName)
{
    var functionsToSort = $(selectName + ' ' + 'option');
    functionsToSort.sort(function(a,b)
    {
       var textA = a.text.toUpperCase();
       var textB = b.text.toUpperCase();
       return (textA < textB) ? -1 : (textA > textB) ? 1 : 0;
    });
    $(selectName).html(functionsToSort);
}


function eulaAccept()
{
   var xhr = new XMLHttpRequest();
   xhr.open('POST', '/start.eulaaccept', true);
   xhr.setRequestHeader("Content-type", "text/plain");
   xhr.send("done");
   $('#eula').modal('hide')
   xhr.onreadystatechange = function() {
       if (this.readyState == 4 && this.status == 200)
       {
           window.location.reload(true);
       }
   };
}

function eulaReject()
{
   var xhr = new XMLHttpRequest();
   xhr.open('POST', '/start.eulareject', true);
   xhr.setRequestHeader("Content-type", "text/plain");
   xhr.send("done");
   $('#eula').modal('hide');
   alerts=document.getElementById("messages");
   var alert = document.createElement("div");
   var msg   = document.createTextNode("Because you did not accept the EULA SongKong has been shutdown");
   alert.className = "alert alert-danger";
   alert.appendChild(msg);
   alerts.appendChild(alert);

   xhr.onreadystatechange = function() {
       if (this.readyState == 4 && this.status == 200)
       {

       }
   };
}

function verify()
{
    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/license.process_melco', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(document.getElementById("licenseEmail").value+":"+document.getElementById("licenseKey1").value+":"+document.getElementById("licenseKey2").value);
    xhr.onreadystatechange = function() {
            if (this.readyState == 4 && this.status == 200)
            {
                if(xhr.responseText.startsWith('ok'))
                {
                    addInfoToModal(document.getElementById("verifyLicenseMessages"),xhr.responseText.substring(3));
                    document.getElementById("button_continue_id").disabled = false;
                    document.getElementById("button_continue_id").focus();
                }
                else
                {
                    addAlertToModal(document.getElementById("verifyLicenseMessages"),xhr.responseText.substring(6));
                }
            }
        };
}

function verified()
{
    $('#licenseId').hide();
    $('#eula').modal({keyboard:false});
}

function getMelcoLiteLicense()
{
    var email = document.getElementById("licenseEmailEntry").value;

    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/license.get_melco_license', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(email);
    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText.startsWith('ok'))
            {
                addInfoToModal(document.getElementById("requestLicenseMessages"),xhr.responseText.substring(3));
            }
            else
            {
                addAlertToModal(document.getElementById("requestLicenseMessages"),xhr.responseText.substring(6));
            }
        }
    };
}

function log()
{
    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/license.log_melco', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send("started");
}