/*
Switch to selected tab
*/
function openTab(evt, tabName)
{
    // Declare all variables
    var i, tabcontent, tablinks;

    // Get all elements with class="tabcontent" and hide them
    tabcontent = document.getElementsByClassName("tabcontent");
    for (i = 0; i < tabcontent.length; i++)
    {
        tabcontent[i].style.display = "none";
    }

    // Get all elements with class="tablinks" and remove the class "active"
    tablinks = document.getElementsByClassName("tablinks");
    for (i = 0; i < tablinks.length; i++)
    {
        tablinks[i].className = tablinks[i].className.replace(" active", "");
    }

    // Show the current tab, and add an "active" class to the button that opened the tab
    document.getElementById(tabName).style.display = "block";
    evt.currentTarget.className += " active";
}

/*
Reset options on this tab to what they were when page was first loaded
*/
function resetOptions(divName)
{
    var inputs = document.getElementById(divName).getElementsByTagName('input');
    for (i = 0; i < inputs.length; i++)
    {
        if(inputs[i].type=='checkbox')
        {
            if(inputs[i].defaultChecked)
            {
                inputs[i].checked=true;
            }
            else
            {
                inputs[i].checked=false;
            }
        }
        else
        {
            inputs[i].value=inputs[i].defaultValue;
        }
    }

    inputs = document.getElementById(divName).getElementsByTagName('select');
    for (i = 0; i < inputs.length; i++)
    {
  	    for(j = 0; j < inputs[i].options.length; j++)
  	    {
  		    var option = inputs[i].options[j];
  		    option.selected = option.defaultSelected;
  	    }
    }
}

/** Show/Hide Help
*/
function showHelp()
{
	 //If currently not shown then show
	 var advancedButtons = document.getElementsByName("help");
	 var firstButton = advancedButtons[0];

	 var showHelpEnabled = document.getElementsByName("SHOW_HELP_ENABLED");
	 var firstShowHelp   = showHelpEnabled[0];

	 if(firstButton.value=="false")
	 {
	   firstShowHelp.value = "true";

	 	 for (i = 0; i < advancedButtons.length; i++)
	   {
	   		advancedButtons[i].value="true";
	   		advancedButtons[i].innerHTML=advancedButtons[i].getAttribute('data-hidehelp');
	   }
	   var inputs = document.getElementsByName("helpfield");
	   for (i = 0; i < inputs.length; i++)
	   {
	      inputs[i].style.display = "block";
	   }
	 }
	 //If shown then hide
	 else
	 {
        firstShowHelp.value = "false";
	 	for (i = 0; i < advancedButtons.length; i++)
	    {
	   		advancedButtons[i].value="false";
	   		advancedButtons[i].innerHTML=advancedButtons[i].getAttribute('data-showhelp');
	   }
	   var inputs = document.getElementsByName("helpfield");
	   for (i = 0; i < inputs.length; i++)
	   {
	      inputs[i].style.display = "none";
	   }
	 }
}

/*
* Disable/Enable an input field and label based on value of select
*/
function disableInput(selectbox, inputfield, disableValue)
{
    select   = document.getElementById(selectbox);
    selected = select.options[select.selectedIndex].value;
    if(selected==disableValue)
    {
    	document.getElementById(inputfield).disabled = true;
    	document.getElementById(inputfield+"label").className="optionlabeldisabled";
    }
    else
    {
    	document.getElementById(inputfield).disabled = false;
    	document.getElementById(inputfield+"label").className="optionlabel";
    }
}

/*
* Hide/Show an form control based on value of select
*/
function hideInput(selectbox, inputfield, disableValue)
{
    select   = document.getElementById(selectbox);
    selected = select.options[select.selectedIndex].value;
    if(selected==disableValue)
    {
      document.getElementById(inputfield+"control").style.display="none";
      if (document.getElementById(inputfield+"label") != null)
    	{
    		document.getElementById(inputfield+"label").style.display="none";
    	}
    }
    else
    {
    	document.getElementById(inputfield+"control").style.display="block";
    	if (document.getElementById(inputfield+"label") != null)
    	{
    		document.getElementById(inputfield+"label").style.display="block";
    	}
    }
}


/*
* Hide/Show a form control based on if a checkbox is selected
*/
function cbHideInput(checkbox, inputfield)
{
    check   = document.getElementById(checkbox);
    if (check.checked == true)
    {
    	document.getElementById(inputfield+"control").style.display="block";
    	if (document.getElementById(inputfield+"label") != null)
    	{
    		document.getElementById(inputfield+"label").style.display="block";
    	}
    }
    else
    {
      document.getElementById(inputfield+"control").style.display="none";
      if (document.getElementById(inputfield+"label") != null)
    	{
    		document.getElementById(inputfield+"label").style.display="none";
    	}
    }
}

/*
Use when need to disable input and associated label
*/
function disableInputAndLabel(inputName)
{
		document.getElementById(inputName).disabled = true;
		document.getElementById(inputName+'label').className="d-block optionlabeldisabled";
}


/*
Use when need to enable input and associated label
*/
function enableInputAndLabel(inputName)
{
		document.getElementById(inputName).disabled = false;
		document.getElementById(inputName+'label').className="d-block optionlabel";
}




function moveBetweenList(list1, list2)
{
    // Get the selected
    var allSelected = Array.prototype.slice.call(list1.querySelectorAll('option:checked'));

    // Loop over the array
    allSelected.forEach(
        function(selOption)
        {
            list2.appendChild(selOption);  // Add each to the second list
        }
    );
}

/*
Update the contents and length of read only badges associated with multi-select field
*/
function getSelectValues(select, readonlylist)
{
	  var result = '';
    var options = select && select.options;
    var opt;

    for (var i=0, iLen=options.length; i<iLen; i++)
    {
        opt = options[i];
        if (opt.selected)
        {
            result+='<span class="badge badge-secondary ml-1">' + opt.text + '</span>';
        }
    }
    readonlylist.innerHTML =result;
    return result;
}

/**
Orderable List - update hidden field
*/
function updateInput(list, input) {
  var values = [];
  for (let li of list.querySelectorAll('li')) {
    values.push(li.dataset.value);
  }
  input.value = values.join(';');
}

/**
Orderable List
*/
function orderInput(list, upButton, downButton, input) {
  updateInput(list, input);

	for (let li of list.querySelectorAll('li')) {
	  li.addEventListener('click', () => {
	    for (let sibling of li.parentNode.children) {
	      if (!sibling.isSameNode(li)) {
	        sibling.classList.remove('selected');
	      }
	    }
	    li.classList.toggle('selected');
	  });
	}

	// enable moving an element up
	upButton.addEventListener('click', () => {
	  var li = list.querySelector('li.selected');
	  if (li.previousElementSibling !== null) {
	    li.parentNode.insertBefore(li, li.previousElementSibling);
	    updateInput(list, input);
	  }
	});

	// enable moving an element down
	downButton.addEventListener('click', () => {
	  var li = list.querySelector('li.selected');
	  if (li.nextElementSibling !== null) {
	    li.parentNode.insertBefore(li, li.nextElementSibling.nextElementSibling);
	    updateInput(list, input);
	  }
	});
}

/**
Check all inputs within divName
*/
function selectAll(divName)
{
    var inputs  = document.getElementById(divName).querySelectorAll("input[type='checkbox']")
    for (i = 0; i < inputs.length; i++)
    {
    	inputs[i].checked=true;
    }
}


/**
Check all inputs within divName
*/
function unselectAll(divName)
{
    var inputs  = document.getElementById(divName).querySelectorAll("input[type='checkbox']")
    for (i = 0; i < inputs.length; i++)
    {
    	inputs[i].checked=false;
    }
}

